#property indicator_chart_window 
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Green 
#property indicator_color3 Red  


#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 2

//---- input parameters 
extern int period=16; 
extern int method=3; // MODE_SMA 
extern int price=0; // PRICE_CLOSE 

//---- buffers 

double Uptrend[];
double Dntrend[];

double ExtMapBuffer[];

double vect[]; 


int p;
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init() { 
   IndicatorBuffers(4); 
   SetIndexBuffer(0, ExtMapBuffer); 
   SetIndexBuffer(1, Uptrend); 
   SetIndexBuffer(2, Dntrend); 
   SetIndexBuffer(3, vect); 
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);

   p = MathSqrt(period); 
   
   SetIndexDrawBegin(0,period+p);
   SetIndexDrawBegin(1,period+p);
   SetIndexDrawBegin(2,period+p);
   SetIndexDrawBegin(3,period+p);
   SetIndexDrawBegin(4,period+p);

   IndicatorShortName("HMA("+period+")"); 
   SetIndexLabel(1,"UP");
   SetIndexLabel(2,"DN");


   return(0); 
} 

//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function | 
//+------------------------------------------------------------------+ 
int deinit() { return(0); } 

//+------------------------------------------------------------------+ 
//| ?????????? ??????? | 
//+------------------------------------------------------------------+ 
double WMA(int x, int p) { return(iMA(NULL, 0, p, 0, method, price, x)); } 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function | 
//+------------------------------------------------------------------+ 
int start() { 
   int counted_bars = IndicatorCounted(); 

   


   int i, limit;
   
   limit=Bars - counted_bars;

   if (limit>0){
      limit=Bars-1;
   }

   for(i = limit; i >= 0; i--)    vect[i]          = 2*WMA(i, period/2) - WMA(i, period); 
   for(i = limit; i >= 0; i--)    ExtMapBuffer[i]  = iMAOnArray(vect, 0, p, 0, MODE_SMA, i); 
   for(i = limit; i >= 0; i--) { 
      Uptrend[i] = EMPTY_VALUE; 
      Dntrend[i] = EMPTY_VALUE; 
         if (ExtMapBuffer[i]> vect[i]) 
         {
            Uptrend[i] = ExtMapBuffer[i];
            Uptrend[i+1] = ExtMapBuffer[i+1];
         } 
         else 
         {
         if (ExtMapBuffer[i]< vect[i]) 
         {
            Dntrend[i] = ExtMapBuffer[i];
            Dntrend[i+1] = ExtMapBuffer[i+1];
         } 
      }
   }
   return(0); 
} 
//+------------------------------------------------------------------+

string Period_toStr(){
   switch (Period()) {
      case PERIOD_M1:    return("M1" );
      case PERIOD_M5:    return("M5" );
      case PERIOD_M15:   return("M15");
      case PERIOD_M30:   return("M30");
      case PERIOD_H1:    return("H1" );
      case PERIOD_H4:    return("H4" );
      case PERIOD_D1:    return("D1" );
      case PERIOD_W1:    return("W1" );
      case PERIOD_MN1:   return("MN1");
   }
}